class MenuState:
    def __init__(self, title, desc):
        self.title = title
        self.description = desc
        self.parent = None
        self.subs = []

    def add_submenu(self, menu):
        self.subs.append(menu)
        menu.parent = self

    def display_CLI(self):
        display_text = f'\n{self.title}\n'
        if self.parent != None:
            display_text += f'  b. Back\n'
        for i in range(0, len(self.subs)):
            sub = self.subs[i]
            display_text += f'  {i}. {sub.title}\n'
            display_text += f'    - {sub.description}\n'
        return display_text, False
    
    def nav_to_sub(self, sub_index):
        if sub_index <= len(self.subs):
            return self.subs[sub_index]
        else:
            return self
        
    def nav_to_parent(self):
        if self.parent != None:
            return self.parent
        else:
            return self
        

class LeafMenu(MenuState):

    def set_action(self, action, args):
        self.action = action
        self.args = args

    def display_CLI(self):
        return self.action(self.args), True